<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
	<xsl:template match="/">
		<html>
			<head/>
			<body>
				<xsl:for-each select="QdmProject">
					<xsl:for-each select="Payitem">
						<xsl:if test="position()=1">
							<xsl:text disable-output-escaping="yes">&lt;table border="1"&gt;</xsl:text>
						</xsl:if>
						<xsl:if test="position()=1">
							<thead>
								<tr bgcolor="#D7E7F7">
									<td align="center"><b>Name</b></td>
									<td align="center"><b>Description</b></td>
									<td align="center"><b>Unit</b></td>
									<td align="center"><b>Unit Cost</b></td>
									<td align="center"><b>Total Quantity</b></td>
									<td align="center"><b>Total Cost</b></td>
								</tr>
							</thead>
						</xsl:if>
						<xsl:if test="position()=1">
							<xsl:text disable-output-escaping="yes">&lt;tbody&gt;</xsl:text>
						</xsl:if>
						<tr>
							<td>
								<xsl:for-each select="Name">
									<xsl:apply-templates/>
								</xsl:for-each>
							</td>
							<td>
								<xsl:for-each select="Description">
									<xsl:apply-templates/>
								</xsl:for-each>
							</td>
							<td>
								<xsl:for-each select="Unit">
									<xsl:apply-templates/>
								</xsl:for-each>
							</td>
							<td align="right">
								<xsl:for-each select="UnitCost">
									<xsl:apply-templates/>
								</xsl:for-each>
							</td>
							<td align="right">
								<xsl:value-of select="format-number(TotalQuantity,'#0.00')"/>
							</td>
							<td align="center">
								<xsl:value-of select="format-number(TotalCost,'#0.00')"/>
							</td>
						</tr>
						<xsl:if test="position()=last()">
							<xsl:text disable-output-escaping="yes">&lt;/tbody&gt;</xsl:text>
						</xsl:if>
						<xsl:if test="position()=last()">
							<xsl:text disable-output-escaping="yes">&lt;/table&gt;</xsl:text>
						</xsl:if>
					</xsl:for-each>
				</xsl:for-each>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
