<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema">
	<xsl:template match="/">
		<xsl:for-each select="QdmProject">absolute station,STATION TO STATION,LOCATION ,QTY,payitem number,payitem description,unit,phase,chain,run,remarks,description,extended description
<xsl:for-each select="Payitem">
				<xsl:for-each select="Quantity">
					<xsl:choose>
						<xsl:when test="count(Chain)&gt;0">
							<xsl:variable name="stationMin">
								<xsl:apply-templates select="MinimumStation"/>
							</xsl:variable>
							<xsl:variable name="stationMax">
								<xsl:apply-templates select="MaximumStation"/>
							</xsl:variable>
							<xsl:variable name="offsetMax">
								<xsl:call-template name="offset-text-transform">
									<xsl:with-param name="text" select="format-number(MaximumStation/Offset,'#0')"/>
								</xsl:call-template>
							</xsl:variable>
							<xsl:variable name="offsetMin">
								<xsl:call-template name="offset-text-transform">
									<xsl:with-param name="text" select="format-number(MinimumStation/Offset,'#0')"/>
								</xsl:call-template>
							</xsl:variable>
							<xsl:value-of select="format-number(MinimumStation/AbsoluteStation,'#0')"/>,<xsl:choose>
								<xsl:when test="$stationMin = $stationMax">
									<xsl:value-of select="$stationMin"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="$stationMin"/> - <xsl:value-of select="$stationMax"/>
								</xsl:otherwise>
							</xsl:choose>,<xsl:choose>
								<xsl:when test="$offsetMin = $offsetMax">
									<xsl:value-of select="$offsetMin"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="$offsetMin"/> - <xsl:value-of select="$offsetMax"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>,,</xsl:otherwise>
					</xsl:choose>,<xsl:value-of select="RoundedValue"/>
					<xsl:text>,"</xsl:text>
					<xsl:call-template name="duplicate-the-double-quotes">
						<xsl:with-param name="text" select="../Name"/>
					</xsl:call-template>
					<xsl:text>","</xsl:text>
					<xsl:call-template name="duplicate-the-double-quotes">
						<xsl:with-param name="text" select="../Description"/>
					</xsl:call-template>
					<xsl:text>",</xsl:text>
					<xsl:value-of select="../Unit"/>,<xsl:value-of select="../@phase"/>,<xsl:value-of select="Chain"/>
					<xsl:text>,</xsl:text>
					<xsl:value-of select="RunName"/>
					<xsl:text>,"</xsl:text>
					<xsl:call-template name="duplicate-the-double-quotes">
						<xsl:with-param name="text" select="Remarks"/>
					</xsl:call-template>
					<xsl:text>","</xsl:text>
					<xsl:call-template name="duplicate-the-double-quotes">
						<xsl:with-param name="text" select="Description"/>
					</xsl:call-template>
					<xsl:text>","</xsl:text>
					<xsl:call-template name="duplicate-the-double-quotes">
						<xsl:with-param name="text" select="ExtendedDescription"/>
					</xsl:call-template>
					<xsl:text>",
</xsl:text>
					<xsl:for-each select="/QdmProject/Payitem"/>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>
	<!--template to transform offsets. -->
	<xsl:template name="offset-text-transform">
		<xsl:param name="text"/>
		<xsl:variable name="replace">-</xsl:variable>
		<xsl:choose>
			<xsl:when test="number($text) = 0">
				<xsl:value-of select="$text"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="$text &lt; 0">
						<xsl:value-of select="substring-after($text,$replace)"/> LT</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$text"/> RT</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- template to output a custom formatted station. -->
	<xsl:template match="MinimumStation | MaximumStation">
		<xsl:variable name="plusNumber">2</xsl:variable>
		<!-- this variable can be changed. it defines the place where the + sign is to be placed in the station string-->
		<xsl:variable name="station">
			<xsl:value-of select="format-number(Station,'#0')"/>
		</xsl:variable>
		<xsl:variable name="stationWithPlus">
			<xsl:choose>
				<xsl:when test="string-length($station)&lt;($plusNumber+1) or $plusNumber=0">
					<xsl:value-of select="$station"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:variable name="plusPosition">
						<xsl:value-of select="string-length($station)-($plusNumber+0)"/>
					</xsl:variable>
					<xsl:value-of select="substring($station,1,$plusPosition)"/>+<xsl:value-of select="substring($station,$plusPosition+1,string-length($station))"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:value-of select="$stationWithPlus"/> R <xsl:value-of select="Region"/>
	</xsl:template>
	<!--template to replace the double quotes with two double quotes. -->
	<xsl:template name="duplicate-the-double-quotes">
		<xsl:param name="text"/>
		<xsl:variable name="replace">"</xsl:variable>
		<xsl:choose>
			<xsl:when test="contains($text, $replace)">
				<xsl:value-of select="substring-before($text, $replace)"/>
				<xsl:text disable-output-escaping="no">""</xsl:text>
				<xsl:call-template name="duplicate-the-double-quotes">
					<xsl:with-param name="text" select="substring-after($text, $replace)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
